  Infile$ = LTRIM$(RTRIM$(COMMAND$))

  PRINT "Nintendo 64 ToolKit: Boot code dumper v0.4 by anarko <anarko@flashback.net>"
  PRINT

  IF Infile$ = "" THEN
     PRINT " Program for dumping the boot code from Nintendo 64 ROM's,"
     PRINT " to be used together with other Nintendo 64 ToolKit programs."
     PRINT
     PRINT " Syntax: N64BOOT <infile>"
     END
  ELSE
      temp = INSTR(Infile$, ".")
      IF temp = 0 THEN
         OutFile$ = Infile$ + ".bot"
      ELSE
         OutFile$ = LEFT$(Infile$, temp - 1) + ".bot"
         DO
           temp = INSTR(OutFile$, "\")
           IF temp > 0 THEN
              OutFile$ = MID$(OutFile$, temp + 1)
           ELSE
              slutvillkor = 1
           END IF
         LOOP WHILE slutvillkor = 0
      END IF
   END IF
  
   OPEN Infile$ FOR BINARY AS #1
        IF LOF(1) = 0 THEN
           PRINT " "; Infile$; " does not exist."
           CLOSE #1
           KILL Infile$
           END
        END IF
  
   head$ = "  "
   GET #1, &H1, head$
   IF head$ = CHR$(&H80) + CHR$(&H37) THEN ROM.Format = 1
   IF head$ = CHR$(&H37) + CHR$(&H80) THEN ROM.Format = 2
   IF ROM.Format = 0 THEN
      PRINT " Infile is not a valid ROM image."
      CLOSE #1, #2
      END
   END IF
  
   OPEN OutFile$ FOR BINARY AS #2
   PRINT "  Writing boot code for "; Infile$; " ..";

   
   IF ROM.Format = 1 THEN
      temp$ = SPACE$(4032)
      GET #1, &H41, temp$
      PUT #2, , temp$
   ELSE
      temp$ = "    "
      FOR a = &H41 TO &H1000 STEP 4
          GET #1, a, temp$
          tmput$ = ""
          FOR ttx = 1 TO LEN(temp$) STEP 2
              tmp1$ = MID$(temp$, ttx, 1)
              tmp2$ = MID$(temp$, ttx + 1, 1)
              tmput$ = tmput$ + tmp2$ + tmp1$
          NEXT
          PUT #2, , tmput$
      NEXT a
   END IF
   PRINT " Done."
   
   CLOSE #1, #2
   PRINT "  Boot header stored in "; OutFile$

   END

